package net.minecraft.src;

import net.lax1dude.eaglercraft.TextureLocation;
import org.lwjgl.opengl.GL11;

public class RenderSkeleton extends RenderBiped
{
    private static final TextureLocation skeletonTextures = new TextureLocation("textures/entity/skeleton/skeleton.png");
    private static final TextureLocation witherSkeletonTextures = new TextureLocation("textures/entity/skeleton/wither_skeleton.png");

    public RenderSkeleton()
    {
        super(new ModelSkeleton(), 0.5F);
    }

    protected void scaleSkeleton(EntitySkeleton par1EntitySkeleton, float par2)
    {
        if (par1EntitySkeleton.getSkeletonType() == 1)
        {
            GL11.glScalef(1.2F, 1.2F, 1.2F);
        }
    }

    protected void func_82422_c()
    {
        GL11.glTranslatef(0.09375F, 0.1875F, 0.0F);
    }

    protected TextureLocation func_110860_a(EntitySkeleton par1EntitySkeleton)
    {
        return par1EntitySkeleton.getSkeletonType() == 1 ? witherSkeletonTextures : skeletonTextures;
    }

    protected TextureLocation func_110856_a(EntityLiving par1EntityLiving)
    {
        return this.func_110860_a((EntitySkeleton)par1EntityLiving);
    }

    /**
     * Allows the render to do any OpenGL state modifications necessary before the model is rendered. Args:
     * entityLiving, partialTickTime
     */
    protected void preRenderCallback(EntityLivingBase par1EntityLivingBase, float par2)
    {
        this.scaleSkeleton((EntitySkeleton)par1EntityLivingBase, par2);
    }

    /**
     * Returns the location of an entity's texture. Doesn't seem to be called unless you call Render.bindEntityTexture.
     */
    protected TextureLocation getEntityTexture(Entity par1Entity)
    {
        return this.func_110860_a((EntitySkeleton)par1Entity);
    }
}
